Index: branches/UKMO/r6232_obs_oper_update/NEMOGCM/NEMO/OPA_SRC/OBS/obs_write.F90
===================================================================
--- branches/UKMO/r6232_obs_oper_update/NEMOGCM/NEMO/OPA_SRC/OBS/obs_write.F90	(revision 15754)
+++ branches/UKMO/r6232_obs_oper_update/NEMOGCM/NEMO/OPA_SRC/OBS/obs_write.F90	(revision 15764)
@@ -28,5 +28,5 @@
    USE obs_const
    USE obs_mpp              ! MPP support routines for observation diagnostics
-   USE lib_mpp		    ! MPP routines
+   USE lib_mpp              ! MPP routines
 
    IMPLICIT NONE
@@ -95,6 +95,10 @@
       INTEGER :: je
       INTEGER :: iadd
+      INTEGER :: iadd_clm ! 1 if climatology present
       INTEGER :: iext
       REAL(wp) :: zpres
+
+      iadd_clm = 0  
+      IF ( profdata%lclim ) iadd_clm = 1
 
       IF ( PRESENT( padd ) ) THEN
@@ -137,4 +141,10 @@
          fbdata%caddunit(1,1) = 'Degrees centigrade'
          fbdata%caddunit(1,2) = 'PSU'
+         IF ( profdata%lclim ) THEN 
+            fbdata%caddlong(2,1) = 'Climatology interpolated potential temperature' 
+            fbdata%caddlong(2,2) = 'Climatology interpolated practical salinity' 
+            fbdata%caddunit(2,1) = 'Degrees centigrade' 
+            fbdata%caddunit(2,2) = 'PSU' 
+         ENDIF
          fbdata%cgrid(:)      = 'T'
          DO je = 1, iext
@@ -170,4 +180,10 @@
          fbdata%caddunit(1,1) = 'm/s'
          fbdata%caddunit(1,2) = 'm/s'
+         IF ( profdata%lclim ) THEN 
+            fbdata%caddlong(2,1) = 'Climatology interpolated zonal velocity' 
+            fbdata%caddlong(2,2) = 'Climatology interpolated meridional velocity' 
+            fbdata%caddunit(2,1) = 'm/s' 
+            fbdata%caddunit(2,2) = 'm/s' 
+         ENDIF
          fbdata%cgrid(1)      = 'U' 
          fbdata%cgrid(2)      = 'V'
@@ -252,4 +268,8 @@
          fbdata%caddlong(1,1) = 'Model interpolated ' // TRIM(cllongname)
          fbdata%caddunit(1,1) = clunits
+         IF ( profdata%lclim ) THEN 
+            fbdata%caddlong(2,1) = 'Climatological interpolated ' // TRIM(cllongname) 
+            fbdata%caddunit(2,1) = clunits 
+         ENDIF
          fbdata%cgrid(:)      = clgrid
          DO je = 1, iext
@@ -266,4 +286,6 @@
 
       fbdata%caddname(1)   = 'Hx'
+
+      IF ( profdata%lclim ) fbdata%caddname(1+iadd_clm)   = 'CLM'
 
       WRITE(clfname, FMT="(A,'_fdbk_',I4.4,'.nc')") TRIM(clfiletype), nproc
@@ -319,5 +341,4 @@
             DO jk = profdata%npvsta(jo,jvar), profdata%npvend(jo,jvar)
                ik = profdata%var(jvar)%nvlidx(jk)
-               fbdata%padd(ik,jo,1,jvar) = profdata%var(jvar)%vmod(jk)
                fbdata%pob(ik,jo,jvar)    = profdata%var(jvar)%vobs(jk)
                fbdata%pdep(ik,jo)        = profdata%var(jvar)%vdep(jk)
@@ -327,5 +348,5 @@
                   fbdata%ivlqc(ik,jo,jvar) = IBSET(profdata%var(jvar)%nvqc(jk),2)
                   fbdata%ivlqcf(1,ik,jo,jvar) = profdata%var(jvar)%nvqcf(1,jk)
-                  fbdata%ivlqcf(2,ik,jo,jvar) = IAND(profdata%var(jvar)%nvqc(jk),b'0000 0000 1111 1111')
+                  fbdata%ivlqcf(2,ik,jo,jvar) = IAND(profdata%var(jvar)%nvqc(jk),b'0000000011111111')
                ELSE
                   fbdata%ivlqc(ik,jo,jvar) = profdata%var(jvar)%nvqc(jk)
@@ -333,6 +354,10 @@
                ENDIF
                fbdata%iobsk(ik,jo,jvar)  = profdata%var(jvar)%mvk(jk)
-               DO ja = 1, iadd
-                  fbdata%padd(ik,jo,1+ja,jvar) = &
+               fbdata%padd(ik,jo,1,jvar) = profdata%var(jvar)%vmod(jk) 
+               IF ( profdata%lclim ) THEN            
+                  fbdata%padd(ik,jo,1+iadd_clm,jvar) = profdata%var(jvar)%vclm(jk)      
+               ENDIF               
+               DO ja = 1, iadd 
+                  fbdata%padd(ik,jo,1+iadd_clm+ja,jvar) = &
                      & profdata%var(jvar)%vext(jk,padd%ipoint(ja))
                END DO
@@ -416,19 +441,24 @@
       INTEGER :: ja
       INTEGER :: je
+      INTEGER :: jv
       INTEGER :: iadd
       INTEGER :: iext
       INTEGER :: indx_std
       INTEGER :: iadd_std
-
+      INTEGER :: iadd_clm      
+      INTEGER :: iadd_mdt
+
+      IF ( PRESENT( pext ) ) THEN 
+         iext = pext%inum 
+      ELSE 
+         iext = 0 
+      ENDIF 
+
+      ! Set up number of additional variables to be ouput: 
+      ! Hx, CLM, STD, MDT...
       IF ( PRESENT( padd ) ) THEN
          iadd = padd%inum
       ELSE
          iadd = 0
-      ENDIF
-
-      IF ( PRESENT( pext ) ) THEN
-         iext = pext%inum
-      ELSE
-         iext = 0
       ENDIF
 
@@ -444,4 +474,10 @@
       ENDIF
       
+      iadd_clm = 0 
+      IF ( surfdata%lclim ) iadd_clm = 1 
+
+      iadd_mdt = 0 
+      IF ( TRIM(surfdata%cvars(1)) == 'SLA' ) iadd_mdt = 1 
+
       CALL init_obfbdata( fbdata )
 
@@ -451,7 +487,9 @@
          ! SLA needs special treatment because of MDT, so is all done here
          ! Other variables are done more generically
-
-         CALL alloc_obfbdata( fbdata, 1, surfdata%nsurf, 1, &
-            &                 2 + iadd + iadd_std, 1 + iext, .TRUE. )
+         ! No climatology for SLA, MDT is our best estimate of that and is already output.
+
+         CALL alloc_obfbdata( fbdata, 1, surfdata%nsurf, 1, & 
+            &                 1 + iadd_mdt + iadd_std + iadd, & 
+            &                 1 + iext, .TRUE. )
 
          clfiletype = 'slafb'
@@ -493,4 +531,20 @@
          clgrid     = 'T'
 
+      CASE('SIT') 
+
+         clfiletype    = 'sitfb' 
+         cllongname    = 'Sea ice thickness' 
+         clunits       = 'm' 
+         clgrid        = 'T' 
+
+      CASE('FBD') 
+
+         clfiletype = 'fbdfb' 
+         ! Change label from FBD ("freeboard") to SIT ("Sea Ice Thickness") 
+         surfdata%cvars(1) = 'SIT' 
+         cllongname = 'Sea ice thickness' 
+         clunits    = 'm' 
+         clgrid     = 'T' 
+
       CASE('SSS')
 
@@ -500,101 +554,118 @@
          clgrid     = 'T'
 
-      CASE('SLCHLTOT','LOGCHL','LogChl','logchl')
-
-         clfiletype = 'slchltotfb'
-         cllongname = 'Surface total log10(chlorophyll)'
-         clunits    = 'log10(mg/m3)'
-         clgrid     = 'T'
-
-      CASE('SLCHLDIA')
-
-         clfiletype = 'slchldiafb'
-         cllongname = 'Surface diatom log10(chlorophyll)'
-         clunits    = 'log10(mg/m3)'
-         clgrid     = 'T'
-
-      CASE('SLCHLNON')
-
-         clfiletype = 'slchlnonfb'
-         cllongname = 'Surface non-diatom log10(chlorophyll)'
-         clunits    = 'log10(mg/m3)'
-         clgrid     = 'T'
-
-      CASE('SLCHLDIN')
-
-         clfiletype = 'slchldinfb'
-         cllongname = 'Surface dinoflagellate log10(chlorophyll)'
-         clunits    = 'log10(mg/m3)'
-         clgrid     = 'T'
-
-      CASE('SLCHLMIC')
-
-         clfiletype = 'slchlmicfb'
-         cllongname = 'Surface microphytoplankton log10(chlorophyll)'
-         clunits    = 'log10(mg/m3)'
-         clgrid     = 'T'
-
-      CASE('SLCHLNAN')
-
-         clfiletype = 'slchlnanfb'
-         cllongname = 'Surface nanophytoplankton log10(chlorophyll)'
-         clunits    = 'log10(mg/m3)'
-         clgrid     = 'T'
-
-      CASE('SLCHLPIC')
-
-         clfiletype = 'slchlpicfb'
-         cllongname = 'Surface picophytoplankton log10(chlorophyll)'
-         clunits    = 'log10(mg/m3)'
-         clgrid     = 'T'
-
-      CASE('SCHLTOT')
-
-         clfiletype = 'schltotfb'
-         cllongname = 'Surface total chlorophyll'
-         clunits    = 'mg/m3'
-         clgrid     = 'T'
-
-      CASE('SLPHYTOT')
-
-         clfiletype = 'slphytotfb'
-         cllongname = 'Surface total log10(phytoplankton carbon)'
-         clunits    = 'log10(mmolC/m3)'
-         clgrid     = 'T'
-
-      CASE('SLPHYDIA')
-
-         clfiletype = 'slphydiafb'
-         cllongname = 'Surface diatom log10(phytoplankton carbon)'
-         clunits    = 'log10(mmolC/m3)'
-         clgrid     = 'T'
-
-      CASE('SLPHYNON')
-
-         clfiletype = 'slphynonfb'
-         cllongname = 'Surface non-diatom log10(phytoplankton carbon)'
-         clunits    = 'log10(mmolC/m3)'
-         clgrid     = 'T'
-
-      CASE('SSPM')
-
-         clfiletype = 'sspmfb'
-         cllongname = 'Surface suspended particulate matter'
-         clunits    = 'g/m3'
-         clgrid     = 'T'
-
-      CASE('SFCO2','FCO2','fCO2','fco2')
-
-         clfiletype = 'sfco2fb'
-         cllongname = 'Surface fugacity of carbon dioxide'
-         clunits    = 'uatm'
-         clgrid     = 'T'
-
-      CASE('SPCO2')
-
-         clfiletype = 'spco2fb'
-         cllongname = 'Surface partial pressure of carbon dioxide'
-         clunits    = 'uatm'
-         clgrid     = 'T'
+      CASE('UVEL') 
+
+         clfiletype    = 'ssvfb' 
+         cllongname    = 'Eastward sea surface velocity' 
+         clunits       = 'm s-1' 
+         clgrid        = 'U' 
+         cllongname    = 'Northward sea surface velocity' 
+         clunits       = 'm s-1' 
+         clgrid        = 'V' 
+
+      CASE('SLCHLTOT') 
+
+         clfiletype    = 'slchltotfb' 
+         cllongname    = 'Surface total log10(chlorophyll)' 
+         clunits       = 'log10(mg/m3)' 
+         clgrid        = 'T' 
+
+      CASE('SLCHLDIA') 
+
+         clfiletype    = 'slchldiafb' 
+         cllongname    = 'Surface diatom log10(chlorophyll)' 
+         clunits       = 'log10(mg/m3)' 
+         clgrid        = 'T' 
+
+      CASE('SLCHLNON') 
+
+         clfiletype    = 'slchlnonfb' 
+         cllongname    = 'Surface non-diatom log10(chlorophyll)' 
+         clunits       = 'log10(mg/m3)' 
+         clgrid        = 'T' 
+
+      CASE('SLCHLDIN') 
+
+         clfiletype    = 'slchldinfb' 
+         cllongname    = 'Surface dinoflagellate log10(chlorophyll)' 
+         clunits       = 'log10(mg/m3)' 
+         clgrid        = 'T' 
+
+      CASE('SLCHLMIC') 
+
+         clfiletype    = 'slchlmicfb' 
+         cllongname    = 'Surface microphytoplankton log10(chlorophyll)' 
+         clunits       = 'log10(mg/m3)' 
+         clgrid        = 'T' 
+
+      CASE('SLCHLNAN') 
+
+         clfiletype    = 'slchlnanfb' 
+         cllongname    = 'Surface nanophytoplankton log10(chlorophyll)' 
+         clunits       = 'log10(mg/m3)' 
+         clgrid        = 'T' 
+
+      CASE('SLCHLPIC') 
+
+         clfiletype    = 'slchlpicfb' 
+         cllongname    = 'Surface picophytoplankton log10(chlorophyll)' 
+         clunits       = 'log10(mg/m3)' 
+         clgrid        = 'T' 
+
+      CASE('SCHLTOT') 
+
+         clfiletype = 'schltotfb' 
+         cllongname = 'Surface total chlorophyll' 
+         clunits    = 'mg/m3' 
+         clgrid     = 'T' 
+
+      CASE('SLPHYTOT') 
+
+         clfiletype    = 'slphytotfb' 
+         cllongname    = 'Surface total log10(phytoplankton carbon)' 
+         clunits       = 'log10(mmolC/m3)' 
+         clgrid        = 'T' 
+
+      CASE('SLPHYDIA') 
+
+         clfiletype    = 'slphydiafb' 
+         cllongname    = 'Surface diatom log10(phytoplankton carbon)' 
+         clunits       = 'log10(mmolC/m3)' 
+         clgrid        = 'T' 
+
+      CASE('SLPHYNON') 
+
+         clfiletype    = 'slphynonfb' 
+         cllongname    = 'Surface non-diatom log10(phytoplankton carbon)' 
+         clunits       = 'log10(mmolC/m3)' 
+         clgrid        = 'T' 
+
+      CASE('SSPM') 
+
+         clfiletype    = 'sspmfb' 
+         cllongname    = 'Surface suspended particulate matter' 
+         clunits       = 'g/m3' 
+         clgrid        = 'T' 
+
+      CASE('SKD490') 
+
+         clfiletype    = 'skd490fb' 
+         cllongname    = 'Surface attenuation coefficient of downwelling radiation at 490 nm' 
+         clunits       = 'm-1' 
+         clgrid        = 'T' 
+
+      CASE('SFCO2') 
+
+         clfiletype    = 'sfco2fb' 
+         cllongname    = 'Surface fugacity of carbon dioxide' 
+         clunits       = 'uatm' 
+         clgrid        = 'T' 
+
+      CASE('SPCO2') 
+
+         clfiletype    = 'spco2fb' 
+         cllongname    = 'Surface partial pressure of carbon dioxide' 
+         clunits       = 'uatm' 
+         clgrid        = 'T'
 
       CASE DEFAULT
@@ -607,38 +678,52 @@
       ! Remaining variables treated more generically
 
-      IF ( TRIM(surfdata%cvars(1)) /= 'SLA' ) THEN
-      
-         CALL alloc_obfbdata( fbdata, 1, surfdata%nsurf, 1, &
-            &                 1 + iadd + iadd_std, iext, .TRUE. )
-
-         fbdata%cname(1)      = surfdata%cvars(1)
-         fbdata%coblong(1)    = cllongname
-         fbdata%cobunit(1)    = clunits
-         DO je = 1, iext
-            fbdata%cextname(je) = pext%cdname(je)
-            fbdata%cextlong(je) = pext%cdlong(je,1)
-            fbdata%cextunit(je) = pext%cdunit(je,1)
-         END DO
-         IF ( TRIM(surfdata%cvars(1)) == 'ICECONC' ) THEN
-            fbdata%caddlong(1,1) = 'Model interpolated ICE'
-         ELSE
-            fbdata%caddlong(1,1) = 'Model interpolated ' // TRIM(surfdata%cvars(1))
-         ENDIF
-         fbdata%caddunit(1,1) = clunits
-         fbdata%cgrid(1)      = clgrid
-         DO ja = 1, iadd
-            fbdata%caddname(1+iadd_std+ja) = padd%cdname(ja)
-            fbdata%caddlong(1+iadd_std+ja,1) = padd%cdlong(ja,1)
-            fbdata%caddunit(1+iadd_std+ja,1) = padd%cdunit(ja,1)
-         END DO
-
+      IF ( TRIM(surfdata%cvars(1)) /= 'SLA' ) THEN 
+
+         CALL alloc_obfbdata( fbdata, surfdata%nvar, surfdata%nsurf, 1, & 
+            &                 1 + iadd_std + iadd_clm + iadd, iext, .TRUE. ) 
+
+         DO jv = 1, surfdata%nvar 
+            fbdata%cname(jv)      = surfdata%cvars(jv) 
+            fbdata%coblong(jv)    = cllongname 
+            fbdata%cobunit(jv)    = clunits
+         END DO 
+         DO je = 1, iext 
+            fbdata%cextname(je) = pext%cdname(je) 
+            fbdata%cextlong(je) = pext%cdlong(je,1) 
+            fbdata%cextunit(je) = pext%cdunit(je,1) 
+         END DO 
+         DO jv = 1, surfdata%nvar          
+            IF ( TRIM(surfdata%cvars(1)) == 'ICECONC' ) THEN 
+               fbdata%caddlong(1,jv) = 'Model interpolated ICE' 
+            ELSE 
+               fbdata%caddlong(1,jv) = 'Model interpolated ' // TRIM(surfdata%cvars(jv)) 
+            ENDIF 
+            fbdata%caddunit(1,jv) = clunits
+            fbdata%cgrid(jv)      = clgrid
+         END DO             
+         DO ja = 1, iadd 
+            fbdata%caddname(1+iadd_mdt+iadd_std+iadd_clm+ja) = padd%cdname(ja) 
+            DO jv = 1, surfdata%nvar                      
+               fbdata%caddlong(1+iadd_mdt+iadd_std+iadd_clm+ja,jv) = padd%cdlong(ja,jv) 
+               fbdata%caddunit(1+iadd_mdt+iadd_std+iadd_clm+ja,jv) = padd%cdunit(ja,jv) 
+            END DO 
+         END DO 
       ENDIF
       
       fbdata%caddname(1)   = 'Hx'
-      IF ( indx_std /= -1 ) THEN
-         IF ( TRIM(surfdata%cvars(1)) == 'SLA' ) iadd_std = iadd_std + 1
-         fbdata%caddname(1+iadd_std)   = surfdata%cext(indx_std)
-         fbdata%caddlong(1+iadd_std,1) = 'Obs error standard deviation'
-         fbdata%caddunit(1+iadd_std,1) = fbdata%cobunit(1)
+      IF ( indx_std /= -1 ) THEN 
+         fbdata%caddname(1+iadd_mdt+iadd_std)   = surfdata%cext(indx_std) 
+         DO jv = 1, surfdata%nvar                         
+            fbdata%caddlong(1+iadd_mdt+iadd_std,1) = 'Obs error standard deviation' 
+            fbdata%caddunit(1+iadd_mdt+iadd_std,1) = fbdata%cobunit(1) 
+         END DO 
+      ENDIF 
+
+      IF ( surfdata%lclim ) THEN 
+         fbdata%caddname(1+iadd_mdt+iadd_std+iadd_clm)   = 'CLM' 
+         DO jv = 1, surfdata%nvar                                  
+            fbdata%caddlong(1+iadd_mdt+iadd_std+iadd_clm,jv) = 'Climatology' 
+            fbdata%caddunit(1+iadd_mdt+iadd_std+iadd_clm,jv) = fbdata%cobunit(1) 
+         END DO 
       ENDIF
       
@@ -649,5 +734,5 @@
          WRITE(numout,*)'obs_wri_surf :'
          WRITE(numout,*)'~~~~~~~~~~~~~'
-         WRITE(numout,*)'Writing '//TRIM(surfdata%cvars(1))//' feedback file : ',TRIM(clfname)
+         WRITE(numout,*)'Writing '//TRIM(clfiletype)//' feedback file : ',TRIM(clfname)
       ENDIF
 
@@ -663,5 +748,5 @@
             fbdata%ioqc(jo)    = 4
             fbdata%ioqcf(1,jo) = 0
-            fbdata%ioqcf(2,jo) = IAND(surfdata%nqc(jo),b'0000 0000 1111 1111')
+            fbdata%ioqcf(2,jo) = IAND(surfdata%nqc(jo),b'0000000011111111')
          ELSE
             fbdata%ioqc(jo)    = surfdata%nqc(jo)
@@ -675,9 +760,13 @@
          fbdata%kindex(jo)    = surfdata%nsfil(jo)
          IF (ln_grid_global) THEN
-            fbdata%iobsi(jo,1) = surfdata%mi(jo)
-            fbdata%iobsj(jo,1) = surfdata%mj(jo)
+            DO jv = 1, surfdata%nvar 
+               fbdata%iobsi(jo,jv) = surfdata%mi(jo,jv) 
+               fbdata%iobsj(jo,jv) = surfdata%mj(jo,jv) 
+            END DO
          ELSE
-            fbdata%iobsi(jo,1) = mig(surfdata%mi(jo))
-            fbdata%iobsj(jo,1) = mjg(surfdata%mj(jo))
+            DO jv = 1, surfdata%nvar          
+               fbdata%iobsi(jo,jv) = mig(surfdata%mi(jo,jv)) 
+               fbdata%iobsj(jo,jv) = mjg(surfdata%mj(jo,jv)) 
+            END DO
          ENDIF
          CALL greg2jul( 0, &
@@ -689,33 +778,48 @@
             &           fbdata%ptim(jo),   &
             &           krefdate = 19500101 )
-         fbdata%padd(1,jo,1,1) = surfdata%rmod(jo,1)
-         IF ( TRIM(surfdata%cvars(1)) == 'SLA' ) fbdata%padd(1,jo,2,1) = surfdata%rext(jo,1)
-         fbdata%pob(1,jo,1)    = surfdata%robs(jo,1) 
          fbdata%pdep(1,jo)     = 0.0
          fbdata%idqc(1,jo)     = 0
          fbdata%idqcf(:,1,jo)  = 0
-         IF ( surfdata%nqc(jo) > 255 ) THEN
-            fbdata%ivqc(jo,1)       = 4
-            fbdata%ivlqc(1,jo,1)    = 4
-            fbdata%ivlqcf(1,1,jo,1) = 0
-            fbdata%ivlqcf(2,1,jo,1) = IAND(surfdata%nqc(jo),b'0000 0000 1111 1111')
-         ELSE
-            fbdata%ivqc(jo,1)       = surfdata%nqc(jo)
-            fbdata%ivlqc(1,jo,1)    = surfdata%nqc(jo)
-            fbdata%ivlqcf(:,1,jo,1) = 0
-         ENDIF
-         fbdata%iobsk(1,jo,1)  = 0
-         IF ( TRIM(surfdata%cvars(1)) == 'SLA' ) fbdata%pext(1,jo,1) = surfdata%rext(jo,2)
-         IF ( indx_std /= -1 ) THEN
-            fbdata%padd(1,jo,1+iadd_std,1) = surfdata%rext(jo,indx_std)
-         ENDIF
-         
-         DO ja = 1, iadd
-            fbdata%padd(1,jo,2+iadd_std+ja,1) = &
-               & surfdata%rext(jo,padd%ipoint(ja))
-         END DO
-         DO je = 1, iext
-            fbdata%pext(1,jo,1+je) = &
-               & surfdata%rext(jo,pext%ipoint(je))
+         DO jv = 1, surfdata%nvar  
+            fbdata%pob(1,jo,jv)    = surfdata%robs(jo,jv) 
+
+            IF ( surfdata%nqc(jo) > 255 ) THEN 
+               fbdata%ivqc(jo,jv)       = 4 
+               fbdata%ivlqc(1,jo,jv)    = 4 
+               fbdata%ivlqcf(1,1,jo,jv) = 0 
+               fbdata%ivlqcf(2,1,jo,jv) = IAND(surfdata%nqc(jo),b'0000000011111111') 
+            ELSE 
+               fbdata%ivqc(jo,jv)       = surfdata%nqc(jo) 
+               fbdata%ivlqc(1,jo,jv)    = surfdata%nqc(jo) 
+               fbdata%ivlqcf(:,1,jo,jv) = 0 
+            ENDIF 
+            fbdata%iobsk(1,jo,jv)  = 0 
+
+            ! Additional variables. 
+            ! Hx is always the first additional variable 
+            fbdata%padd(1,jo,1,jv) = surfdata%rmod(jo,jv) 
+            ! MDT is output as an additional variable if SLA obs type 
+            IF ( TRIM(surfdata%cvars(jv)) == 'SLA' ) THEN 
+               fbdata%padd(1,jo,1+iadd_mdt,jv) = surfdata%rext(jo,1) 
+            ENDIF     
+            ! STD is output as an additional variable if available 
+            IF ( indx_std /= -1 ) THEN 
+               fbdata%padd(1,jo,1+iadd_mdt+iadd_std,jv) = surfdata%rext(jo,indx_std) 
+            ENDIF 
+            ! CLM is output as an additional variable if available 
+            IF ( surfdata%lclim ) THEN 
+               fbdata%padd(1,jo,1+iadd_mdt+iadd_std+iadd_clm,jv) = surfdata%rclm(jo,jv) 
+            ENDIF 
+            ! Then other additional variables are output 
+            DO ja = 1, iadd 
+               fbdata%padd(1,jo,1+iadd_mdt+iadd_std+iadd_clm+ja,jv) = & 
+                  & surfdata%rext(jo,padd%ipoint(ja)) 
+            END DO 
+         END DO          
+         ! Extra variables 
+         IF ( TRIM(surfdata%cvars(1)) == 'SLA' ) fbdata%pext(1,jo,1) = surfdata%rext(jo,2)          
+         DO je = 1, iext 
+            fbdata%pext(1,jo,1+je) = & 
+               & surfdata%rext(jo,pext%ipoint(je)) 
          END DO
       END DO
Index: branches/UKMO/r6232_obs_oper_update/NEMOGCM/NEMO/OPA_SRC/OBS/obsinter_z1d.h90
===================================================================
--- branches/UKMO/r6232_obs_oper_update/NEMOGCM/NEMO/OPA_SRC/OBS/obsinter_z1d.h90	(revision 15754)
+++ branches/UKMO/r6232_obs_oper_update/NEMOGCM/NEMO/OPA_SRC/OBS/obsinter_z1d.h90	(revision 15764)
@@ -62,29 +62,52 @@
          z1dm = ( pdep(kkco(jdep)) - pobsdep(jdep)      )
          z1dp = ( pobsdep(jdep)    - pdep(kkco(jdep)-1) )
-         IF ( pobsmask(kkco(jdep)) == 0.0_wp ) z1dp = 0.0_wp
-
-         zsum = z1dm + z1dp
          
-         IF ( k1dint == 0 ) THEN
-
-            !-----------------------------------------------------------------
-            !  Linear interpolation
-            !-----------------------------------------------------------------
-            pobs(jdep) = (   z1dm * pobsk(kkco(jdep)-1) &
-               &           + z1dp * pobsk(kkco(jdep)  ) ) / zsum
-
-         ELSEIF ( k1dint == 1 ) THEN
-
-            !-----------------------------------------------------------------
-            ! Cubic spline interpolation
-            !-----------------------------------------------------------------
-            zsum2 = zsum * zsum
-            pobs(jdep)  = (  z1dm                             * pobsk (kkco(jdep)-1) &
-               &           + z1dp                             * pobsk (kkco(jdep)  ) &
-               &           + ( z1dm * ( z1dm * z1dm - zsum2 ) * pobs2k(kkco(jdep)-1) &
-               &           +   z1dp * ( z1dp * z1dp - zsum2 ) * pobs2k(kkco(jdep)  ) &
-               &             ) / 6.0_wp                                              &
-               &          ) / zsum
-
+         ! Where both levels are masked, return a fill value 
+         IF ( ( pobsmask(kkco(jdep)-1) == 0.0_wp ) .AND. (pobsmask(kkco(jdep)) == 0.0_wp) ) THEN 
+            pobs(jdep)  = 99999. 
+         ELSE 
+          
+            ! Where upper level is masked (e.g., under ice cavity), only use deeper level 
+            ! otherwise where ob is at or above upper level model T-point,  
+            ! use upper model level rather than extrapolate 
+            IF ( pobsmask(kkco(jdep)-1) == 0.0_wp ) THEN 
+               z1dm = 0.0_wp 
+            ELSE IF ( pobsdep(jdep) <= pdep(kkco(jdep)-1) ) THEN 
+               z1dp = 0.0_wp    
+            END IF    
+ 
+            ! Where deeper level is masked (e.g., near sea bed), only use upper level 
+            ! otherwise where ob is at or below deeper level model T-point,  
+            ! use deeper model level rather than extrapolate 
+            IF ( pobsmask(kkco(jdep)) == 0.0_wp ) THEN 
+               z1dp = 0.0_wp 
+            ELSE IF ( pobsdep(jdep) >= pdep(kkco(jdep)) ) THEN 
+               z1dm = 0.0_wp    
+            END IF    
+ 
+            zsum = z1dm + z1dp 
+          
+            IF ( k1dint == 0 ) THEN 
+ 
+               !----------------------------------------------------------------- 
+               !  Linear interpolation 
+               !----------------------------------------------------------------- 
+               pobs(jdep) = (   z1dm * pobsk(kkco(jdep)-1) & 
+                  &           + z1dp * pobsk(kkco(jdep)  ) ) / zsum 
+ 
+            ELSEIF ( k1dint == 1 ) THEN 
+ 
+               !----------------------------------------------------------------- 
+               ! Cubic spline interpolation 
+               !----------------------------------------------------------------- 
+               zsum2 = zsum * zsum 
+               pobs(jdep)  = (  z1dm                             * pobsk (kkco(jdep)-1) & 
+                  &           + z1dp                             * pobsk (kkco(jdep)  ) & 
+                  &           + ( z1dm * ( z1dm * z1dm - zsum2 ) * pobs2k(kkco(jdep)-1) & 
+                  &           +   z1dp * ( z1dp * z1dp - zsum2 ) * pobs2k(kkco(jdep)  ) & 
+                  &             ) / 6.0_wp                                              & 
+                  &          ) / zsum 
+ 
+            ENDIF 
          ENDIF
       END DO
Index: branches/UKMO/r6232_obs_oper_update/NEMOGCM/NEMO/OPA_SRC/TRA/tradmp.F90
===================================================================
--- branches/UKMO/r6232_obs_oper_update/NEMOGCM/NEMO/OPA_SRC/TRA/tradmp.F90	(revision 15754)
+++ branches/UKMO/r6232_obs_oper_update/NEMOGCM/NEMO/OPA_SRC/TRA/tradmp.F90	(revision 15764)
@@ -56,4 +56,7 @@
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   resto    !: restoring coeff. on T and S (s-1)
 
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) :: tclim    !: temperature climatology on each time step(Celcius) 
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) :: sclim    !: salinity climatology on each time step (psu)
+
    !! * Substitutions
 #  include "domzgr_substitute.h90"
@@ -70,5 +73,6 @@
       !!                ***  FUNCTION tra_dmp_alloc  ***
       !!----------------------------------------------------------------------
-      ALLOCATE( strdmp(jpi,jpj,jpk) , ttrdmp(jpi,jpj,jpk), resto(jpi,jpj,jpk), STAT= tra_dmp_alloc )
+      ALLOCATE( strdmp(jpi,jpj,jpk) , ttrdmp(jpi,jpj,jpk), resto(jpi,jpj,jpk), & 
+         &      tclim(jpi,jpj,jpk) , sclim(jpi,jpj,jpk), STAT=tra_dmp_alloc )
       !
       IF( lk_mpp            )   CALL mpp_sum ( tra_dmp_alloc )
@@ -110,4 +114,7 @@
       !                           !==   input T-S data at kt   ==!
       CALL dta_tsd( kt, zts_dta )            ! read and interpolates T-S data at kt
+
+      tclim(:,:,:) = zts_dta(:,:,:,jp_tem) 
+      sclim(:,:,:) = zts_dta(:,:,:,jp_sal)
       !
       SELECT CASE ( nn_zdmp )     !==    type of damping   ==!
